Index: /palm/trunk/UTIL/inifor/src/inifor.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor.f90	(revision 3866)
@@ -402,51 +455,40 @@
 !
 !--                   Select output array of current geostrophic wind component
-                      SELECT CASE(TRIM(output_var % name))
-                      CASE ('ls_forcing_ug')
+                      SELECT CASE( TRIM( output_var%name ) )
+                      CASE ( 'ls_forcing_ug' )
                          ug_vg_palm => ug_palm
-                      CASE ('ls_forcing_vg')
+                      CASE ( 'ls_forcing_vg' )
                          ug_vg_palm => vg_palm
                       END SELECT
 
-                      ALLOCATE( output_arr(1,1,output_var % grid % nz) )
+                      ALLOCATE( output_arr(1,1,output_var%grid%nz) )
                       output_arr(1,1,:) = ug_vg_palm(:)
 
-                   CASE ( 'average scalar' )
-
-                      ALLOCATE( output_arr(1,1,1) )
- CALL run_control('time', 'alloc')
-                      output_arr(1,1,1) = p0
- CALL run_control('time', 'comp')
-
+!--                User defined constant profiles
                    CASE ( 'set profile' )
                       
-                      ALLOCATE( output_arr( 1, 1, 1:nz ) )
- CALL run_control('time', 'alloc')
-
-                      SELECT CASE (TRIM(output_var % name))
-
-                      CASE('nudging_tau')
+                      ALLOCATE( output_arr(1,1,1:nz) )
+                      CALL log_runtime( 'time', 'alloc' )
+
+                      SELECT CASE ( TRIM( output_var%name ) )
+
+                      CASE ( 'nudging_tau' )
                           output_arr(1, 1, :) = NUDGING_TAU
 
                       CASE DEFAULT
-                          message = "'" // TRIM(output_var % name) //          &
-                             "' is not a valid '" // TRIM(output_var % kind) //&
+                          message = "'" // TRIM( output_var%name ) //          &
+                             "' is not a valid '" // TRIM( output_var%kind ) //&
                              "' variable kind."
-                          CALL inifor_abort('main loop', message)
+                          CALL inifor_abort( 'main loop', message )
                       END SELECT
- CALL run_control('time', 'comp')
-
-                   CASE('average large-scale profile')
-                      message = "Averaging of large-scale forcing profiles " //&
-                                "has not been implemented, yet."
-                      CALL inifor_abort('main loop', message)
+                      CALL log_runtime( 'time', 'comp' )
 
                    CASE DEFAULT
-                      message = "Processing task '" // TRIM(output_var % task) //&
+                      message = "Processing task '" // TRIM( output_var%task ) //&
                                "' not recognized."
-                      CALL inifor_abort('', message)
+                      CALL inifor_abort( '', message )
 
                    END SELECT
- CALL run_control('time', 'comp')
+                   CALL log_runtime( 'time', 'comp' )
 
 !------------------------------------------------------------------------------
@@ -458,16 +500,16 @@
 !--                defined on averaged COSMO levels instead of PALM levels
 !--                (requires definiton of COSMO levels in netCDF output.)
-                   !IF (.NOT. output_var % is_internal .OR. debugging_output)  THEN
-
-                   IF (.NOT. output_var % is_internal)  THEN
-                      message = "Writing variable '" // TRIM(output_var%name) // "'."
-                      CALL report('main loop', message)
-                      CALL update_output(output_var, output_arr, iter,         &
-                                         output_file, cfg)
- CALL run_control('time', 'write')
+                   !IF (.NOT. output_var%is_internal .OR. debugging_output)  THEN
+
+                   IF ( .NOT. output_var%is_internal )  THEN
+                      message = "Writing variable '" // TRIM( output_var%name ) // "'."
+                      CALL report( 'main loop', message )
+                      CALL update_output( output_var, output_arr, iter,        &
+                                          output_file, cfg )
+                      CALL log_runtime( 'time', 'write' )
                    ENDIF
 
-                   IF (ALLOCATED(output_arr))  DEALLOCATE(output_arr)
- CALL run_control('time', 'alloc')
+                   IF ( ALLOCATED( output_arr ) )  DEALLOCATE( output_arr )
+                   CALL log_runtime( 'time', 'alloc' )
 
                 ENDIF
@@ -478,5 +520,5 @@
 
              ug_vg_have_been_computed = .FALSE.
-             IF ( group % kind == 'thermodynamics' )  THEN
+             IF ( group%kind == 'thermodynamics' )  THEN
                 DEALLOCATE( rho_centre )
                 DEALLOCATE( ug_palm )
@@ -484,5 +526,5 @@
                 DEALLOCATE( ug_cosmo )
                 DEALLOCATE( vg_cosmo )
-                IF ( .NOT. cfg % ug_defined_by_user )  THEN
+                IF ( .NOT. cfg%ug_defined_by_user )  THEN
                    DEALLOCATE( rho_north )
                    DEALLOCATE( rho_south )
@@ -499,11 +541,11 @@
 !--          Keep input buffer around for averaged (radiation) and 
 !--          accumulated COSMO quantities (precipitation).
-             IF ( group % kind == 'running average' .OR. &
-                  group % kind == 'accumulated' )  THEN
+             IF ( group%kind == 'running average' .OR. &
+                  group%kind == 'accumulated' )  THEN
              ELSE
-                CALL report('main loop', 'Deallocating input buffer', cfg % debug)
-                DEALLOCATE(input_buffer)
+                CALL report( 'main loop', 'Deallocating input buffer', cfg%debug )
+                DEALLOCATE( input_buffer )
              ENDIF
- CALL run_control('time', 'alloc')
+             CALL log_runtime( 'time', 'alloc' )
 
 !
@@ -511,22 +553,22 @@
           ENDDO
 
-          IF (ALLOCATED(input_buffer))  THEN
-             CALL report('main loop', 'Deallocating input buffer', cfg % debug)
-             DEALLOCATE(input_buffer)
+          IF ( ALLOCATED( input_buffer ) )  THEN
+             CALL report( 'main loop', 'Deallocating input buffer', cfg%debug )
+             DEALLOCATE( input_buffer )
           ENDIF
- CALL run_control('time', 'alloc')
+          CALL log_runtime( 'time', 'alloc' )
 
        ELSE 
 
-          message = "Skipping IO group " // TRIM(str(igroup)) // " '" // TRIM(group % kind) // "'"
-          IF ( ALLOCATED(group % in_var_list) )  THEN
-              message = TRIM(message) // " with input variable '" //           &
-              TRIM(group % in_var_list(1) % name) // "'."
+          message = "Skipping IO group " // TRIM( str( igroup ) ) // " '" // TRIM( group%kind ) // "'"
+          IF ( ALLOCATED( group%in_var_list ) )  THEN
+              message = TRIM( message ) // " with input variable '" //         &
+              TRIM( group%in_var_list(1)%name ) // "'."
           ENDIF
 
-          CALL report('main loop', message, cfg % debug)
-
-!
-!--    IO group % to_be_processed conditional
+          CALL report( 'main loop', message, cfg%debug )
+
+!
+!--    IO group%to_be_processed conditional
        ENDIF
 
@@ -538,16 +580,27 @@
 !- Section 3: Clean up.
 !------------------------------------------------------------------------------
-    CALL fini_file_lists()
-    CALL fini_io_groups()
-    CALL fini_variables()
-    !CALL fini_grids()
- CALL run_control('time', 'alloc')
- CALL run_control('report', 'void')
-
-    message = "Finished writing dynamic driver '" // TRIM(output_file % name) // &
+    CALL fini_file_lists
+    CALL fini_io_groups
+    CALL fini_variables
+    !CALL fini_grids
+    CALL log_runtime( 'time', 'alloc' )
+    CALL log_runtime( 'report', 'void' )
+
+    message = "Finished writing dynamic driver '" // TRIM( output_file%name ) // &
               "' successfully."
-    CALL report('main loop', message)
-
-
+    CALL report( 'main loop', message )
+    CALL close_log
+
+#else
+
+    USE inifor_control
+    IMPLICIT NONE
+    
+    message = "INIFOR was compiled without netCDF support, which is required for it to run. "  //     &
+              "To use INIFOR, recompile PALM with netCDF support by adding the -D__netcdf " //        &
+              "precompiler flag to your .palm.config file."
+    CALL inifor_abort( 'main loop', message )
+ 
 #endif
+
  END PROGRAM inifor
Index: /palm/trunk/UTIL/inifor/src/inifor_control.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_control.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_control.f90	(revision 3866)
@@ -26,4 +26,11 @@
 ! -----------------
 ! $Id$
+! Use PALM's working precision
+! Renamed run_control -> log_runtime
+! Open log file only once
+! Improved coding style
+! 
+! 
+! 3785 2019-03-06 10:41:14Z eckhard
 ! Added message buffer for displaying tips to rectify encountered errors
 ! 
@@ -66,10 +73,8 @@
 !> feedback to the terminal and a log file.
 !------------------------------------------------------------------------------!
-#if defined ( __netcdf )
  MODULE inifor_control
 
     USE inifor_defs,                                                           &
-        ONLY:  LNAME, dp, VERSION, COPYRIGHT
-
+        ONLY:  COPYRIGHT, LNAME, LOG_FILE_NAME, VERSION, wp
     USE inifor_util,                                                           &
         ONLY:  real_to_str, real_to_str_f
@@ -79,4 +84,5 @@
     CHARACTER (LEN=5000) ::  message = '' !< log message buffer
     CHARACTER (LEN=5000) ::  tip     = '' !< optional log message buffer for tips on how to rectify encountered errors
+    INTEGER, SAVE        ::  u            !< Fortran file unit for the log file
 
  CONTAINS
@@ -94,36 +100,30 @@
 !> to it.
 !------------------------------------------------------------------------------!
-    SUBROUTINE report(routine, message, debug)
-
-       CHARACTER(LEN=*), INTENT(IN)  ::  routine !< name of calling subroutine of function
-       CHARACTER(LEN=*), INTENT(IN)  ::  message !< log message
-       LOGICAL, OPTIONAL, INTENT(IN) ::  debug   !< flag the current message as debugging message
-
-       INTEGER                       ::  u                     !< Fortran file unit for the log file
-       LOGICAL, SAVE                 ::  is_first_run = .TRUE. !< control flag for file opening mode
-       LOGICAL                       ::  suppress_message      !< control falg for additional debugging log
-
-
-       IF ( is_first_run )  THEN
-          OPEN( NEWUNIT=u, FILE='inifor.log', STATUS='replace' )
-          is_first_run = .FALSE.
-       ELSE
-          OPEN( NEWUNIT=u, FILE='inifor.log', POSITION='append', STATUS='old' )
-       ENDIF
-          
-
-       suppress_message = .FALSE.
-       IF ( PRESENT(debug) )  THEN
-          IF ( .NOT. debug )  suppress_message = .TRUE.
-       ENDIF
-
-       IF ( .NOT. suppress_message )  THEN
-          PRINT *, "inifor: " // TRIM(message) // "  [ " // TRIM(routine) // " ]"
-          WRITE(u, *)  TRIM(message) // "  [ " // TRIM(routine) // " ]"
-       ENDIF
-
-       CLOSE(u)
-
-    END SUBROUTINE report
+ SUBROUTINE report(routine, message, debug)
+
+    CHARACTER(LEN=*), INTENT(IN)  ::  routine !< name of calling subroutine of function
+    CHARACTER(LEN=*), INTENT(IN)  ::  message !< log message
+    LOGICAL, OPTIONAL, INTENT(IN) ::  debug   !< flag the current message as debugging message
+
+    LOGICAL, SAVE                 ::  is_first_run = .TRUE. !< control flag for file opening mode
+    LOGICAL                       ::  suppress_message      !< control falg for additional debugging log
+
+    IF ( is_first_run )  THEN
+       OPEN( NEWUNIT=u, FILE=LOG_FILE_NAME, STATUS='replace' )
+       is_first_run = .FALSE.
+    ENDIF
+       
+
+    suppress_message = .FALSE.
+    IF ( PRESENT(debug) )  THEN
+       IF ( .NOT. debug )  suppress_message = .TRUE.
+    ENDIF
+
+    IF ( .NOT. suppress_message )  THEN
+       PRINT *, "inifor: " // TRIM(message) // "  [ " // TRIM(routine) // " ]"
+       WRITE(u, *)  TRIM(message) // "  [ " // TRIM(routine) // " ]"
+    ENDIF
+
+ END SUBROUTINE report
 
 
@@ -138,12 +138,12 @@
 !> continue.
 !------------------------------------------------------------------------------!
-    SUBROUTINE warn(routine, message)
-
-       CHARACTER(LEN=*), INTENT(IN) ::  routine !< name of calling subroutine or function
-       CHARACTER(LEN=*), INTENT(IN) ::  message !< log message
-
-       CALL report(routine, "WARNING: " // TRIM(message))
-
-    END SUBROUTINE warn
+ SUBROUTINE warn(routine, message)
+
+    CHARACTER(LEN=*), INTENT(IN) ::  routine !< name of calling subroutine or function
+    CHARACTER(LEN=*), INTENT(IN) ::  message !< log message
+
+    CALL report(routine, "WARNING: " // TRIM(message))
+
+ END SUBROUTINE warn
 
 
@@ -158,13 +158,21 @@
 !> INIFOR from continueing.
 !------------------------------------------------------------------------------!
-    SUBROUTINE inifor_abort(routine, message)
-
-       CHARACTER(LEN=*), INTENT(IN) ::  routine !< name of calling subroutine or function
-       CHARACTER(LEN=*), INTENT(IN) ::  message !< log message
-
-       CALL report(routine, "ERROR: " // TRIM(message) // " Stopping.")
-       STOP
-
-    END SUBROUTINE inifor_abort
+ SUBROUTINE inifor_abort(routine, message)
+
+    CHARACTER(LEN=*), INTENT(IN) ::  routine !< name of calling subroutine or function
+    CHARACTER(LEN=*), INTENT(IN) ::  message !< log message
+
+    CALL report(routine, "ERROR: " // TRIM(message) // " Stopping.")
+    CALL close_log
+    STOP
+
+ END SUBROUTINE inifor_abort
+
+
+ SUBROUTINE close_log()
+
+    CLOSE(u)
+
+ END SUBROUTINE close_log
 
 
@@ -175,98 +183,96 @@
 !> print_version() prints the INIFOR version number and copyright notice.
 !------------------------------------------------------------------------------!
-    SUBROUTINE print_version()
-       PRINT *, "INIFOR " // VERSION
-       PRINT *, COPYRIGHT
-    END SUBROUTINE print_version
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> 
-!> run_control() measures the run times of various parts of INIFOR and
+ SUBROUTINE print_version()
+    PRINT *, "INIFOR " // VERSION
+    PRINT *, COPYRIGHT
+ END SUBROUTINE print_version
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> 
+!> log_runtime() measures the run times of various parts of INIFOR and
 !> accumulates them in timing budgets.
 !------------------------------------------------------------------------------!
-    SUBROUTINE run_control(mode, budget)
-
-       CHARACTER(LEN=*), INTENT(IN) ::  mode   !< name of the calling mode
-       CHARACTER(LEN=*), INTENT(IN) ::  budget !< name of the timing budget
-
-       REAL(dp), SAVE ::  t0               !< begin of timing interval
-       REAL(dp), SAVE ::  t1               !< end of timing interval
-       REAL(dp), SAVE ::  t_comp  = 0.0_dp !< computation timing budget
-       REAL(dp), SAVE ::  t_alloc = 0.0_dp !< allocation timing budget
-       REAL(dp), SAVE ::  t_init  = 0.0_dp !< initialization timing budget
-       REAL(dp), SAVE ::  t_read  = 0.0_dp !< reading timing budget
-       REAL(dp), SAVE ::  t_total = 0.0_dp !< total time
-       REAL(dp), SAVE ::  t_write = 0.0_dp !< writing timing budget
-
-       CHARACTER(LEN=*), PARAMETER  ::  fmt='(F6.2)' !< floating-point output format
-
-
-       SELECT CASE(TRIM(mode))
-
-       CASE('init')
-          CALL CPU_TIME(t0)
-
-       CASE('time')
-
-          CALL CPU_TIME(t1)
-
-          SELECT CASE(TRIM(budget))
-
-             CASE('alloc')
-                t_alloc = t_alloc + t1 - t0
-
-             CASE('init')
-                t_init = t_init + t1 - t0
-
-             CASE('read')
-                t_read = t_read + t1 - t0
-
-             CASE('write')
-                t_write = t_write + t1 - t0
-
-             CASE('comp')
-                t_comp = t_comp + t1 - t0
-
-             CASE DEFAULT
-                CALL inifor_abort('run_control', "Time Budget '" // TRIM(mode) // "' is not supported.")
-
-          END SELECT
-
-          t0 = t1
-
-       CASE('report')
-           t_total = t_init + t_read + t_write + t_comp
-
-           CALL report('run_control', " *** CPU time ***")
-
-           CALL report('run_control', "Initialization: " // real_to_str(t_init)  // &
-                       " s (" // TRIM(real_to_str(100*t_init/t_total, fmt))      // " %)")
-
-           CALL report('run_control', "(De-)Allocation:" // real_to_str(t_alloc)  // &
-                       " s (" // TRIM(real_to_str(100*t_alloc/t_total, fmt))      // " %)")
-
-           CALL report('run_control', "Reading data:   " // real_to_str(t_read)  // &
-                       " s (" // TRIM(real_to_str(100*t_read/t_total, fmt))      // " %)")
-
-           CALL report('run_control', "Writing data:   " // real_to_str(t_write) // &
-                       " s (" // TRIM(real_to_str(100*t_write/t_total, fmt))     // " %)")
-
-           CALL report('run_control', "Computation:    " // real_to_str(t_comp)  // &
-                       " s (" // TRIM(real_to_str(100*t_comp/t_total, fmt))      // " %)")
-
-           CALL report('run_control', "Total:          " // real_to_str(t_total) // &
-                       " s (" // TRIM(real_to_str(100*t_total/t_total, fmt))     // " %)")
-
-       CASE DEFAULT
-          CALL inifor_abort('run_control', "Mode '" // TRIM(mode) // "' is not supported.")
+ SUBROUTINE log_runtime(mode, budget)
+
+    CHARACTER(LEN=*), INTENT(IN) ::  mode   !< name of the calling mode
+    CHARACTER(LEN=*), INTENT(IN) ::  budget !< name of the timing budget
+
+    REAL(wp), SAVE ::  t0               !< begin of timing interval
+    REAL(wp), SAVE ::  t1               !< end of timing interval
+    REAL(wp), SAVE ::  t_comp  = 0.0_wp !< computation timing budget
+    REAL(wp), SAVE ::  t_alloc = 0.0_wp !< allocation timing budget
+    REAL(wp), SAVE ::  t_init  = 0.0_wp !< initialization timing budget
+    REAL(wp), SAVE ::  t_read  = 0.0_wp !< reading timing budget
+    REAL(wp), SAVE ::  t_total = 0.0_wp !< total time
+    REAL(wp), SAVE ::  t_write = 0.0_wp !< writing timing budget
+
+    CHARACTER(LEN=*), PARAMETER  ::  fmt='(F6.2)' !< floating-point output format
+
+
+    SELECT CASE(TRIM(mode))
+
+    CASE('init')
+       CALL CPU_TIME(t0)
+
+    CASE('time')
+
+       CALL CPU_TIME(t1)
+
+       SELECT CASE(TRIM(budget))
+
+          CASE('alloc')
+             t_alloc = t_alloc + t1 - t0
+
+          CASE('init')
+             t_init = t_init + t1 - t0
+
+          CASE('read')
+             t_read = t_read + t1 - t0
+
+          CASE('write')
+             t_write = t_write + t1 - t0
+
+          CASE('comp')
+             t_comp = t_comp + t1 - t0
+
+          CASE DEFAULT
+             CALL inifor_abort('log_runtime', "Time Budget '" // TRIM(mode) // "' is not supported.")
 
        END SELECT
 
-    END SUBROUTINE run_control
+       t0 = t1
+
+    CASE('report')
+        t_total = t_init + t_read + t_write + t_comp
+
+        CALL report('log_runtime', " *** CPU time ***")
+
+        CALL report('log_runtime', "Initialization:  " // TRIM( real_to_str( t_init ) ) // &
+                    " s  (" // TRIM( real_to_str( 100 * t_init / t_total, fmt ) ) // " %)" )
+
+        CALL report('log_runtime', "(De-)Allocation: " // TRIM( real_to_str( t_alloc ) ) // &
+                    " s  (" // TRIM( real_to_str( 100 * t_alloc / t_total, fmt ) ) // " %)" )
+
+        CALL report('log_runtime', "Reading data:    " // TRIM( real_to_str( t_read ) )  // &
+                    " s  (" // TRIM( real_to_str( 100 * t_read / t_total, fmt ) ) // " %)" )
+
+        CALL report('log_runtime', "Writing data:    " // TRIM( real_to_str( t_write ) ) // &
+                    " s  (" // TRIM( real_to_str( 100 * t_write / t_total, fmt ) ) // " %)" )
+
+        CALL report('log_runtime', "Computation:     " // TRIM( real_to_str( t_comp ) )  // &
+                    " s  (" // TRIM( real_to_str( 100 * t_comp / t_total, fmt) ) // " %)" )
+
+        CALL report('log_runtime', "Total:           " // TRIM( real_to_str( t_total ) ) // &
+                    " s  (" // TRIM( real_to_str( 100 * t_total / t_total, fmt ) ) // " %)")
+
+    CASE DEFAULT
+       CALL inifor_abort('log_runtime', "Mode '" // TRIM(mode) // "' is not supported.")
+
+    END SELECT
+
+ END SUBROUTINE log_runtime
 
  END MODULE inifor_control
-#endif
-
Index: /palm/trunk/UTIL/inifor/src/inifor_defs.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3866)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! Added parameter for INIFOR's log file name
+! Use PALM's working precision
+! 
+! 
+! 3801 2019-03-15 17:14:25Z eckhard
 ! Defined netCDF variable names for COSMO grid
 ! Bumped version number
@@ -94,14 +99,13 @@
 !> The defs module provides global constants used in INIFOR.
 !------------------------------------------------------------------------------!
-#if defined ( __netcdf )
  MODULE inifor_defs
  
+ USE kinds,                                                                    &
+     ONLY :  wp, iwp
+
  IMPLICIT NONE
 
 ! 
 !-- Parameters for type definitions
- INTEGER, PARAMETER  ::  dp    = 8   !< double precision (8 bytes = 64 bits)
- INTEGER, PARAMETER  ::  sp    = 4   !< single precision (4 bytes = 32 bits)
- INTEGER, PARAMETER  ::  hp    = 2   !< half precision (2 bytes = 16 bits)
  INTEGER, PARAMETER  ::  PATH  = 140 !< length of file path strings
  INTEGER, PARAMETER  ::  LNAME = 150 !< length of long name strings
@@ -111,31 +115,31 @@
 ! 
 !-- Trigonomentry
- REAL(dp), PARAMETER ::  PI = 3.14159265358979323846264338_dp !< Ratio of a circle's circumference to its diamter [-]
- REAL(dp), PARAMETER ::  TO_RADIANS = PI / 180.0_dp           !< Conversion factor from degrees to radiant [-]
- REAL(dp), PARAMETER ::  TO_DEGREES = 180.0_dp / PI           !< Conversion factor from radians to degrees [-]
+ REAL(wp), PARAMETER ::  PI = 3.14159265358979323846264338_wp !< Ratio of a circle's circumference to its diamter [-]
+ REAL(wp), PARAMETER ::  TO_RADIANS = PI / 180.0_wp           !< Conversion factor from degrees to radiant [-]
+ REAL(wp), PARAMETER ::  TO_DEGREES = 180.0_wp / PI           !< Conversion factor from radians to degrees [-]
 
 ! 
 !-- COSMO parameters
  INTEGER, PARAMETER  ::  WATER_ID = 9                !< Integer corresponding to the water soil type in COSMO-DE [-]
- REAL(dp), PARAMETER ::  EARTH_RADIUS = 6371229.0_dp !< Earth radius used in COSMO-DE [m]
- REAL(dp), PARAMETER ::  P_SL = 1e5_dp               !< Reference pressure for computation of COSMO-DE's basic state pressure [Pa]
- REAL(dp), PARAMETER ::  T_SL = 288.15_dp            !< Reference temperature for computation of COSMO-DE's basic state pressure [K]
- REAL(dp), PARAMETER ::  BETA = 42.0_dp              !< logarithmic lapse rate, dT / d ln(p), for computation of COSMO-DE's basic
+ REAL(wp), PARAMETER ::  EARTH_RADIUS = 6371229.0_wp !< Earth radius used in COSMO-DE [m]
+ REAL(wp), PARAMETER ::  P_SL = 1e5_wp               !< Reference pressure for computation of COSMO-DE's basic state pressure [Pa]
+ REAL(wp), PARAMETER ::  T_SL = 288.15_wp            !< Reference temperature for computation of COSMO-DE's basic state pressure [K]
+ REAL(wp), PARAMETER ::  BETA = 42.0_wp              !< logarithmic lapse rate, dT / d ln(p), for computation of COSMO-DE's basic
                                                      !< state pressure [K]
- REAL(dp), PARAMETER ::  RD   = 287.05_dp            !< specific gas constant of dry air, used in computation of COSMO-DE's basic
+ REAL(wp), PARAMETER ::  RD   = 287.05_wp            !< specific gas constant of dry air, used in computation of COSMO-DE's basic
                                                      !< state [J/kg/K]
- REAL(dp), PARAMETER ::  RV   = 461.51_dp            !< specific gas constant of water vapor [J/kg/K]
- REAL(dp), PARAMETER ::  G    = 9.80665_dp           !< acceleration of Earth's gravity, used in computation of COSMO-DE's basic
+ REAL(wp), PARAMETER ::  RV   = 461.51_wp            !< specific gas constant of water vapor [J/kg/K]
+ REAL(wp), PARAMETER ::  G    = 9.80665_wp           !< acceleration of Earth's gravity, used in computation of COSMO-DE's basic
                                                      !< state [m/s/s]
- REAL(dp), PARAMETER ::  RHO_L = 1e3_dp              !< density of liquid water, used to convert W_SO from [kg/m^2] to [m^3/m^3],
+ REAL(wp), PARAMETER ::  RHO_L = 1e3_wp              !< density of liquid water, used to convert W_SO from [kg/m^2] to [m^3/m^3],
                                                      !< in [kg/m^3]
- REAL(dp), PARAMETER ::  HECTO = 100_dp              !< unit conversion factor from hPa to Pa
+ REAL(wp), PARAMETER ::  HECTO = 100_wp              !< unit conversion factor from hPa to Pa
 
 !
 !-- PALM-4U parameters
- REAL(dp), PARAMETER ::  OMEGA   = 7.29e-5_dp !< angular velocity of Earth's rotation [s^-1]
- REAL(dp), PARAMETER ::  P_REF   = 1e5_dp     !< Reference pressure for potential temperature [Pa]
- REAL(dp), PARAMETER ::  RD_PALM = 287.0_dp   !< specific gas constant of dry air, used in computation of PALM-4U's potential temperature [J/kg/K]
- REAL(dp), PARAMETER ::  CP_PALM = 1005.0_dp  !< heat capacity of dry air at constant pressure, used in computation of PALM-4U's potential temperature [J/kg/K]
+ REAL(wp), PARAMETER ::  OMEGA   = 7.29e-5_wp !< angular velocity of Earth's rotation [s^-1]
+ REAL(wp), PARAMETER ::  P_REF   = 1e5_wp     !< Reference pressure for potential temperature [Pa]
+ REAL(wp), PARAMETER ::  RD_PALM = 287.0_wp   !< specific gas constant of dry air, used in computation of PALM-4U's potential temperature [J/kg/K]
+ REAL(wp), PARAMETER ::  CP_PALM = 1005.0_wp  !< heat capacity of dry air at constant pressure, used in computation of PALM-4U's potential temperature [J/kg/K]
 
 ! 
@@ -154,9 +158,9 @@
                                                               !< water cells [-]
  INTEGER, PARAMETER          ::  FORCING_STEP = 1             !< Number of hours between forcing time steps [h]
- REAL(dp), PARAMETER         ::  NUDGING_TAU = 21600.0_dp     !< Nudging relaxation time scale [s]
- CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.4.8'            !< INIFOR version number
+ REAL(wp), PARAMETER         ::  NUDGING_TAU = 21600.0_wp     !< Nudging relaxation time scale [s]
  CHARACTER(LEN=*), PARAMETER ::  COPYRIGHT = 'Copyright 2017-2019 Leibniz Universitaet Hannover' // &
-     ACHAR( 10 ) // ' Copyright 2017-2019 Deutscher Wetterdienst Offenbach' !< Copyright notice
-
+    ACHAR( 10 ) // ' Copyright 2017-2019 Deutscher Wetterdienst Offenbach' !< Copyright notice
+ CHARACTER(LEN=*), PARAMETER ::  LOG_FILE_NAME = 'inifor.log' !< Name of INIFOR's log file
+ CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.4.9rc'          !< INIFOR version number
+ 
  END MODULE inifor_defs
-#endif
